import React, { RefObject } from 'react';
import { ComponentMetaHolder } from '@teambit/react.ui.highlighter.component-metadata.bit-component-meta';
import { Placement } from '../label';
export interface ElementHighlighterProps extends React.HTMLAttributes<HTMLDivElement> {
    /** highlight this element */
    targetRef: RefObject<HTMLElement | null>;
    /** components with metadata to show in the label */
    components?: (ComponentMetaHolder | string)[];
    /** default location of the label */
    placement?: Placement;
    /** customize styles */
    classes?: HighlightClasses;
    /** continually update highlighter to match moving elements */
    watchMotion?: boolean;
}
export { Placement };
export declare type HighlightClasses = {
    container?: string;
    frame?: string;
    label?: string;
};
export declare function ElementHighlighter({ targetRef, components, placement, watchMotion, className, classes, ...props }: ElementHighlighterProps): JSX.Element;
