import React, { RefObject } from 'react';
export interface FrameProps extends React.HTMLAttributes<HTMLDivElement> {
    /** apply the frame to this element  */
    targetRef: RefObject<HTMLElement | null>;
    /**
     * the specific flavor of the frame.
     * @default "redBorderClass"
     */
    stylesClass?: string;
    /** continually update frame position to match moving elements */
    watchMotion?: boolean;
}
export declare function Frame({ targetRef, watchMotion, className, stylesClass, style }: FrameProps): JSX.Element;
