import { ReactComponentMetaHolder } from '@teambit/react.ui.highlighter.component-metadata.bit-component-meta';
import { MatchRule, ComponentMatchRule } from '../rule-matcher';
declare type BubblingOptions = {
    /** filter elements by this rule */
    elementRule?: MatchRule;
    /** filter components by this rule */
    componentRule?: ComponentMatchRule;
    /**
     * continue bubbling when encountering a parent of the same component
     * @default true
     */
    propagateSameParents?: boolean;
};
/** go up the dom tree until reaching a react bit component */
export declare function bubbleToComponent(element: HTMLElement | null, { elementRule, componentRule, propagateSameParents }?: BubblingOptions): {
    element: HTMLElement;
    components: ReactComponentMetaHolder[];
};
export {};
