import React from 'react';
import { ComponentMetaHolder } from '@teambit/react.ui.highlighter.component-metadata.bit-component-meta';
import { MatchRule, ComponentMatchRule } from '../rule-matcher';
declare type HighlightTarget = {
    element: HTMLElement;
    components: ComponentMetaHolder[];
};
export declare type useHoverHighlighterOptions = {
    debounceDuration: number;
    scopeClass: string;
    disabled?: boolean;
    /** filter highlighter targets by this query selector. (May be a more complex object in the future) */
    rule?: MatchRule;
    /** filter targets by this component match rule */
    componentRule?: ComponentMatchRule;
};
/** fires onChange when targeting a new component */
export declare function useHoverHighlighter<T extends HTMLElement = HTMLElement>(onChange: (target?: HighlightTarget) => void, props: React.HTMLAttributes<T>, { debounceDuration, scopeClass, disabled, rule, componentRule }: useHoverHighlighterOptions): {
    onMouseOver: (event: React.MouseEvent<T, MouseEvent>) => void;
    onMouseLeave: (event: React.MouseEvent<T, MouseEvent>) => void;
} | {
    onMouseOver?: undefined;
    onMouseLeave?: undefined;
};
export {};
